// WaveFront Autoloader
// 4/9/94 J. Johnson                               
// Copyright  1994 Turtle Beach Systems, Inc. All Rights Reserved

#include <windows.h>     
#include <mmsystem.h>  
#include <stdlib.h>
#include <ctl3d.h>
#include "wfsynth.h"    
#include "wfgatapi.h"
#include "resource.h"

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{                         
    Ctl3dRegister(hInstance);
    Ctl3dAutoSubclass(hInstance);
    
    if (hPrevInst == NULL)
    {
        // Put up our yucky window, then center it
        HWND hMessageWnd;
        RECT windowRect;
        RECT desktopRect;
        POINT location;  
        HWND hTextWnd;
        char szMessage[_MAX_PATH + MAXPNAMELEN + 80];
        char szFormatString[80];

        hMessageWnd = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_INITIALIZING), NULL, NULL);
        GetWindowRect(GetDesktopWindow(), &desktopRect);
        GetWindowRect(hMessageWnd, &windowRect);
        location.x = (desktopRect.right - desktopRect.left)/2 
            - (windowRect.right - windowRect.left)/2;
        location.y = (desktopRect.bottom - desktopRect.top)/2 
            - (windowRect.bottom - windowRect.top)/2;
        SetWindowPos(hMessageWnd, NULL, location.x, location.y, 0, 0,
            SWP_NOZORDER | SWP_NOSIZE | SWP_SHOWWINDOW);
        UpdateWindow(hMessageWnd);
    
        // Load the Gatekeeper. This ensures that it will remain 
        // in memory throughout the Windows session
        LoadLibrary("WFGATE.DLL");

        // Get a pointer to the static control in the "dialog",
        // and put up the initial message
        hTextWnd = GetDlgItem(hMessageWnd, IDC_MESSAGE);
        LoadString(hInstance, IDS_SEARCHING, szMessage, sizeof(szMessage));   
        SetWindowText(hTextWnd, szMessage);

        // Tell the Gatekeeper who we are, then initialize.
        // (The window is set to NULL because this program does not 
        // process progress messages)
        GateSetOwner(GetCurrentTask(), NULL);
        GateInitialize();

        // Now initialize each synth
        int nSynthCount = GateGetWaveFrontSynthCount();
        for (int nSynth = 0; nSynth < nSynthCount; nSynth++)
        {
            char szSynthName[32];
            
            // Put up the appropriate message
            LoadString(hInstance, IDS_INITIALIZING, szFormatString, sizeof(szFormatString));   
            GateGetSynthName(nSynth, szSynthName);
            wsprintf(szMessage, szFormatString, szSynthName);
            SetWindowText(hTextWnd, szMessage);
            
            GateInitializeSynth(nSynth, NULL);

            // Shut off the synth's MIDI ports
            GateCloseSynth(nSynth);
        }
        
        // outta here 
        DestroyWindow(hMessageWnd);
    }

    Ctl3dUnregister(hInstance);
    return(1);
}
